######################################
#  L-System Script ver1.10
#
#  2001 Armagan YAVUZ
#  
#  Latest version can be obtained from:
#        www.geocities.com/blenderdungeon/
#
#  2003-06-18: adaptet for Linux by Guido Socher
#  homepage: http://pepper.linuxfocus.org/~guido
#  
######################################
#                                    #
# PRESS ALT+P TO ACTIVATE THE SCRIPT #
#                                    #
######################################
# Modify the line below to set a default directory 

defaultdir = "/home/katja/treemaker-0.1"

import Blender
import sys
import math
from lsystem import *
from rulesets import *
from stemRules import *
from leafRules import *
from Blender.Draw import *
from Blender.BGL import *
from string import strip

#print "DBG: python path is:"
#print sys.path

curversion = 110

num_params = 1
params = []
for i in range(num_params):
  params.append(Create(0.5))

stemparams = []
for i in range(num_params):
  stemparams.append(Create(0.5))


force = [Create(0.0), Create(0.0), Create(0.0)]
scaleforce = Create(0.0)
iteration= Create(2)
resolutionLOD= Create(0.75)
resolution= Create(16)
resolutionV= Create(2)
stemresolutionV= Create(2)
leafresolutionV= Create(1)
repeat= Create(1)
stemrepeat= Create(1)
leafrepeat= Create(1)
bangle = Create(90.0)
stembangle = Create(90.0)
leafbangle = Create(90.0)
menu= Create(5)
stemmenu= Create(1)
leafmenu= Create(1)
leafname= Create("a")
useleaf = Create(1)
leafscale = Create(1.0)
thickness = Create(0.1)
length = Create(0.5)
leaflength = Create(1.0)
rotF = Create(0.0)
stemrotF = Create(0.0)
leafrotF = Create(0.0)
curve = Create(0.0)
stemcurve = Create(0.0)
leafcurve = Create(0.0)
stemorientation = Create(0.0)
conism = Create(0.05)
shorten = Create(0.05)
branch_scale = Create(0.75)
stembranch_scale = Create(0.75)
lenscale = Create(0.75)
stemlenscale = Create(0.75)
prune = Create(0.0)
prunefirst = Create(0)
rot_rand_per = Create(0.1)
rot_rand_abs = Create(0.1)
leafbank = Create(0.0)
maxdepth = Create(30)

message = "Ready"

filename = Create(defaultdir)

def writeln(f,x):
  f.write(str(x))
  f.write("\n")

def readint(f):
  return int(f.readline())
def readfloat(f):
  return float(f.readline())
def readstr(f):
  s = (f.readline())
  return strip(s)

def do_file(save):
  fname = filename.val
  global message, iteration, params, stemparams, menu, stemmenu,leafmenu,thickness, length, leaflength, rotF, stemrotF, leafrotF,conism , branch_scale, stembranch_scale, lenscale, stemlenscale
  global prune, prunefirst, resolutionLOD, resolution, resolutionV, stemresolutionV, leafresolutionV, repeat, stemrepeat, leafrepeat, rot_rand_per,rot_rand_abs,leafname,useleaf,leafscale
  global force,scaleforce,bangle,stembangle,leafbangle
  global curve,stemcurve,leafcurve,stemorientation,leafbank,shorten,maxdepth

  if save:  message = "file saved."
  else:     message = "file loaded."

  if save:
    try:
      f = open(fname,'w')
    except:
      message = "unable to save file."
      return
  else:
    try:
      f = open(fname,'r')
    except:
      message = "file not found."
      return

  if save:  writeln(f,curversion)
  else:
    version = readint(f)
    if version != curversion:
      message = "wrong file version"
  if save:  writeln(f,iteration.val)
  else:     iteration.val = readint(f)

  if save:  writeln(f,params[0].val)
  else:     params[0].val = readfloat(f)
  if save:  writeln(f,stemorientation.val)
  else:     stemorientation.val = readfloat(f)

  if save:  writeln(f,menu.val)
  else:     menu.val = readint(f)
  if save:  writeln(f,stemmenu.val)
  else:     stemmenu.val = readint(f)
  if save:  writeln(f,leafmenu.val)
  else:     leafmenu.val = readint(f)

  if save:  writeln(f,thickness.val)
  else:     thickness.val = readfloat(f)

  if save:  writeln(f,length.val)
  else:     length.val = readfloat(f)
  if save:  writeln(f,leaflength.val)
  else:     leaflength.val = readfloat(f)

  if save:  writeln(f,rotF.val)
  else:     rotF.val = readfloat(f)
  if save:  writeln(f,stemrotF.val)
  else:     stemrotF.val = readfloat(f)
  if save:  writeln(f,leafrotF.val)
  else:     leafrotF.val = readfloat(f)

  if save:  writeln(f,conism.val)
  else:     conism.val = readfloat(f)

  if save:  writeln(f,branch_scale.val)
  else:     branch_scale.val = readfloat(f)
  if save:  writeln(f,stembranch_scale.val)
  else:     stembranch_scale.val = readfloat(f)
  if save:  writeln(f,lenscale.val)
  else:     lenscale.val = readfloat(f)
  if save:  writeln(f,stemlenscale.val)
  else:     stemlenscale.val = readfloat(f)

  if save:  writeln(f,prune.val)
  else:     prune.val = readfloat(f)
  if save:  writeln(f,prunefirst.val)
  else:     prunefirst.val = readint(f)

  if save:  writeln(f,resolutionLOD.val)
  else:     resolutionLOD.val = readfloat(f)
  if save:  writeln(f,resolution.val)
  else:     resolution.val = readint(f)
  if save:  writeln(f,resolutionV.val)
  else:     resolutionV.val = readint(f)
  if save:  writeln(f,stemresolutionV.val)
  else:     stemresolutionV.val = readint(f)
  if save:  writeln(f,repeat.val)
  else:     repeat.val = readint(f)
  if save:  writeln(f,stemrepeat.val)
  else:     stemrepeat.val = readint(f)
  if save:  writeln(f,leafrepeat.val)
  else:     leafrepeat.val = readint(f)

  if save:  writeln(f,rot_rand_per.val)
  else:     rot_rand_per.val = readfloat(f)
  if save:  writeln(f,rot_rand_abs.val)
  else:     rot_rand_abs.val = readfloat(f)

  if save:  writeln(f,leafname.val)
  else:     leafname.val = readstr(f)
  if save:  writeln(f,useleaf.val)
  else:     useleaf.val = readint(f)
  if save:  writeln(f,leafscale.val)
  else:     leafscale.val = readfloat(f)

  if save:  writeln(f,force[0].val)
  else:     force[0].val = readfloat(f)
  if save:  writeln(f,force[1].val)
  else:     force[1].val = readfloat(f)
  if save:  writeln(f,force[2].val)
  else:     force[2].val = readfloat(f)
  if save:  writeln(f,scaleforce.val)
  else:     scaleforce.val = readfloat(f)

  if save:  writeln(f,bangle.val)
  else:     bangle.val = readfloat(f)
  if save:  writeln(f,stembangle.val)
  else:     stembangle.val = readfloat(f)
  if save:  writeln(f,leafbangle.val)
  else:     leafbangle.val = readfloat(f)

  if save:  writeln(f,curve.val)
  else:     curve.val = readfloat(f)
  if save:  writeln(f,stemcurve.val)
  else:     stemcurve.val = readfloat(f)
  if save:  writeln(f,leafcurve.val)
  else:     leafcurve.val = readfloat(f)

  if save:  writeln(f,leafbank.val)
  else:     leafbank.val = readfloat(f)
  if save:  writeln(f,shorten.val)
  else:     shorten.val = readfloat(f)

  if save:  writeln(f,maxdepth.val)
  else:     maxdepth.val = readint(f)

  f.close()



def draw():
	global message, iteration, params, stemorientation,stemparams, menu, stemmenu,leafmenu,thickness, length, leaflength, rotF, stemrotF, leafrotF,conism , branch_scale, stembranch_scale, lenscale, stemlenscale, prune, prunefirst, resolutionLOD, resolution, resolutionV, stemresolutionV, leafresolutionV, repeat, stemrepeat, leafrepeat, rot_rand_per,rot_rand_abs,leafname,useleaf,leafscale,force,scaleforce,bangle,stembangle,leafbangle
	global curve,stemcurve,leafcurve,leafbank,shorten,maxdepth

	global filename

	glClearColor(0.6, 0.6, 0.65, 0.0)
	glClear(GL_COLOR_BUFFER_BIT)

	glColor3f(0.5,0.95,0.5)
	glRasterPos2i(30, 520)
	Text("L-System script for Linux, original from www.geocities.com/blenderdungeon/")

	filename = String("Filename: ",2, 65, 485, 280, 19, filename.val, 50)
	Button("LOAD", 14, 10, 485, 50, 19)
	Button("SAVE", 15, 350, 485, 50, 19)



	glColor3f(0.2,0.2,0.0)
	glRasterPos2i(20, 465)
	Text("Branches:")
	menu= Menu("Ruleset%t| Straight %x1| Arm1 2D%x10| Arm1 3D%x11| Arm1+1 2D%x4| Arm1+1 3D%x12| Split2 2D%x2| Split2 3D%x3| Arm2 2D%x5| Arm2 3D%x6| Arm2+2 %x7| Split3%x8| Arm3%x9", 2, 100, 460, 100, 18, menu.val)

	params[0]= Slider("subOrient  ", 2, 10, 360, 190, 18, params[0].val, 0.0, 1.0)
	bangle = Slider("subSlope ", 2, 10, 380, 190, 18, bangle.val, 0.0, 180.0)
	lenscale = Slider("subLen ", 2, 10, 340, 190, 18, lenscale.val, 0.5, 1.0)
	branch_scale = Slider("subThickns", 2, 10, 320, 190, 18, branch_scale.val, 0.5, 1.0)
	rotF= Slider("Spin  ", 2, 10, 420, 190, 18, rotF.val, -360.0, 360.0)
	curve= Slider("Curve  ", 2, 10, 400, 190, 18, curve.val, -360.0, 360.0)
	resolutionV= Number("resolutionV: ", 2, 10, 440, 85, 19, resolutionV.val, 1, 16)
	repeat= Number("repeat: ", 2, 100, 440, 100, 19, repeat.val, 1, 10)

	glColor3f(0.2,0.1,0.0)
	glRasterPos2i(220, 465)
	Text("Stem:")
	stemmenu= Menu("Ruleset%t| None %x1| Straight%x2| Arm1%x3| Arm1+1%x4| Arm2%x5| Arm2+2%x6| Arm3%x7", 2, 300, 460, 100, 18, stemmenu.val)

	stemorientation= Slider("subOrient ", 2, 210, 360, 190, 18, stemorientation.val, -180.0, 180.0)
	stembangle = Slider("subSlope ", 2, 210, 380, 190, 18, stembangle.val, 0.0, 180.0)
	stemlenscale = Slider("subLen ", 2, 210, 340, 190, 18, stemlenscale.val, 0.2, 2.0)
	stembranch_scale = Slider("subThickns", 2, 210, 320, 190, 18, stembranch_scale.val, 0.5, 1.0)
	stemrotF= Slider("Spin  ", 2, 210, 420, 190, 18, stemrotF.val, -360.0, 360.0)
	stemcurve= Slider("Curve  ", 2, 210, 400, 190, 18, stemcurve.val, -360.0, 360.0)
	stemresolutionV= Number("resolutionV: ", 2, 210, 440, 85, 19, stemresolutionV.val, 1, 16)
	stemrepeat= Number("repeat: ", 2, 300, 440, 100, 19, stemrepeat.val, 1, 30)


	glColor3f(0.0,0.2,0.0)
	glRasterPos2i(220, 295)
	Text("Leaves:")
	leafmenu= Menu("Ruleset%t| EndPoint%x1|Active Point%x7| 1+1 Parallel%x2| 1+1 Perpend.%x3| 2 Parallel%x4| 2 Perpend.%x5| 2+2 Perpend.%x6| 3 Perpend.%x8", 2, 300, 290, 100, 18, leafmenu.val)
	leafrepeat= Number("repeat: ", 2, 300, 270, 100, 19, leafrepeat.val, 1, 30)
	leafbangle = Slider("LeafSlope ", 2, 210, 190, 190, 18, leafbangle.val, 0.0, 180.0)
	leafrotF= Slider("ExtraSpin  ", 2, 210, 230, 190, 18, leafrotF.val, -90.0, 90.0)
	leafcurve= Slider("ExtraCurve  ", 2, 210, 210, 190, 18, leafcurve.val, -90.0, 90.0)
	leafresolutionV= Number("resolutionV: ", 2, 210, 270, 85, 19, leafresolutionV.val, 1, 1)
	leafbank = Slider("LeafOrient ", 2, 210, 170, 190, 18, leafbank.val, 0.0, 90.0)
	leaflength= Slider("lengthMul ", 2, 210, 250, 190, 18, leaflength.val, 0.2, 5.0)

	useleaf = Toggle("Add Leaves",2, 210, 150, 80, 19, useleaf.val)
	leafname = String("leafobj: ",2, 300, 150, 100, 19, leafname.val, 12)
	leafscale= Slider("LeafScale ", 2, 210, 130, 190, 18, leafscale.val, 0.2, 5.0)


	length= Slider("Scale  ", 2, 10, 105, 190, 18, length.val, 0.0, 1.0)
	thickness= Slider("Radius  ", 2, 10, 85, 190, 18, thickness.val, 0.0, 0.5)
	shorten = Slider("Shorten ", 2, 10, 60, 190, 18, shorten.val, 0.0, 0.2)
	conism= Slider("ThinDwn ", 2, 10, 40, 190, 18, conism.val, 0.0, 0.2)

	glColor3f(0.0,0.0,0.2)
	glRasterPos2i(15, 295)
	Text("Force")
	scaleforce= Slider("useThickness", 2, 50, 290, 150, 18, scaleforce.val, 0.0, 1.0)
	force[0]= Slider("Bearing  ", 2, 10, 270, 190, 18, force[0].val, 0.0, 360.0)
	force[1]= Slider("Elevation ", 2, 10, 250, 190, 18, force[1].val, -90.0, 90.0)
	force[2]= Slider("Magnitude ", 2, 10, 230, 190, 18, force[2].val, 0.0, 1.0)

	glColor3f(0.2,0.0,0.2)
	glRasterPos2i(20, 205)
	Text("Prune")
	prune = Slider("Prob ", 2, 10, 180, 190, 18, prune.val, 0.0, 0.5)
	prunefirst =  Number("PruneFirst: ", 2, 100, 200, 100, 19, prunefirst.val, 0, 29)
	maxdepth =  Number("MaxDepth: ", 2, 10, 150, 100, 19, maxdepth.val, 0, 30)

	glColor3f(0.2,0.2,0.2)
	glRasterPos2i(20, 130)
	Text("General")
	rot_rand_per = Slider("ReDir ", 2, 210, 105, 150, 18, rot_rand_per.val, 0.0, 1.0)
	rot_rand_abs = Slider("Twist ", 2, 210, 85, 150, 18, rot_rand_abs.val, 0.0, 1.0)


	glColor3f(0.9,0.95,1.0)
	glRasterPos2i(180, 10)
	Text(message)

	Button("EXIT", 1, 320, 5, 80, 19)
	Button("GENERATE", 3, 10, 5, 80, 19)
	iteration= Number("iterations: ", 2, 95, 5, 80, 19, iteration.val, 1, 30)
	resolutionLOD = Slider("LOD ", 2, 210, 60, 150, 18, resolutionLOD.val, 0.0, 1.0)
	resolution= Number("resolutionU: ", 2, 270, 40, 90, 19, resolution.val, 3, 32)





def event(evt, val):	
	if (evt== QKEY and not val): Exit()

def bevent(evt):
	global message
	if   (evt== 1): Exit()
	elif (evt== 2): Draw()
	elif (evt== 14): 
			do_file(0)
			Draw()
	elif (evt== 15): 
			do_file(1)
			Draw()
	elif (evt== 3): 
		message = "Generating mesh..."
		Draw()
		leafobj = None
		if (useleaf.val == 1) and (leafname.val != ""):
			leafobj = Blender.Object.Get(leafname.val)
			if leafobj == None:
				message = "Leaf obj. not found"
				Draw()
				return
		deg2rad =  3.1416 / 180.0
		bang = bangle.val * deg2rad
		nrotF = rotF.val * deg2rad / resolutionV.val
		ncurve = curve.val * deg2rad / resolutionV.val
		if menu.val == 1:
			rules = b_straight(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 2:
			rules = b_split2_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 3:
			rules = b_split2_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 4:
			rules = b_fork1_alt_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 5:
			rules = b_fork2_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 6:
			rules = b_fork2_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 7:
			rules = b_fork2_alt(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 8:
			rules = b_split3(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 9:
			rules = b_fork3(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 10:
			rules = b_fork1_2d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 11:
			rules = b_fork1_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)
		elif menu.val == 12:
			rules = b_fork1_alt_3d(repeat.val,nrotF,ncurve,length.val,branch_scale.val,lenscale.val,bang,resolutionV.val,params[0].val)

		stemrules = None
		stembang = stembangle.val * 3.1416 / 180.0
		nrotF = stemrotF.val * deg2rad / stemresolutionV.val
		ncurve = stemcurve.val * deg2rad / stemresolutionV.val
		if stemmenu.val == 1:
			pass
		elif stemmenu.val == 2:
			stemrules = s_straight(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 3:
			stemrules = s_fork1(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 4:
			stemrules = s_fork1_alt(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 5:
			stemrules = s_fork2(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 6:
			stemrules = s_fork2_alt(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		elif stemmenu.val == 7:
			stemrules = s_fork3(stemrepeat.val,nrotF,ncurve,length.val,stembranch_scale.val,stemlenscale.val,stembang,stemresolutionV.val,stemorientation.val * deg2rad)
		if stemrules:
			rules[0] = stemrules[0] # copy axiom from stem
			rules[1].extend(stemrules[1])
			rules[2].extend(stemrules[2])

		leafrules = None
		leafbang = leafbangle.val * 3.1416 / 180.0
		leaf_len = leaflength.val * length.val
		nrotF = (leafrotF.val + rotF.val / leafrepeat.val)* deg2rad 
		ncurve = (leafcurve.val + curve.val / leafrepeat.val)* deg2rad 
		if leafmenu.val == 1:
			leafrules = l_endpoint(resolutionV.val,deg2rad * rotF.val / resolutionV.val,deg2rad * curve.val / resolutionV.val,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 7:
			leafrules = l_activepoint(resolutionV.val,deg2rad * rotF.val / resolutionV.val,deg2rad * curve.val / resolutionV.val,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 2:
			leafrules = l_fork1_alt_prl(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 3:
			leafrules = l_fork1_alt_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 4:
			leafrules = l_fork2_prl(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 5:
			leafrules = l_fork2_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 6:
			leafrules = l_fork2_alt_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		elif leafmenu.val == 8:
			leafrules = l_fork3_prp(leafrepeat.val,nrotF,ncurve,leaf_len,stembranch_scale.val,leafbang,leafbank.val*deg2rad,leafresolutionV.val)
		if leafrules:
			rules[1].extend(leafrules[1])
			rules[2].extend(leafrules[2])

		torad = 3.1415926 / 180.0 
		maxd = 30
		if maxdepth.val > 0:
			maxd = maxdepth.val
		cart_force = [math.cos(force[0].val * torad) * math.cos(force[1].val * torad) * force[2].val, math.sin(force[0].val * torad) * math.cos(force[1].val * torad) * force[2].val, math.sin(force[1].val * torad) * force[2].val]
		lsystem_build(rules[0],rules[1],rules[2],iteration.val,length.val*thickness.val,conism.val,shorten.val,resolution.val,resolutionLOD.val,rot_rand_per.val * 4.0,rot_rand_abs.val * 2.0,prune.val, prunefirst.val, maxd, cart_force, scaleforce.val,leafscale.val,leafobj)
		message = "Ready" 
Register(draw, event, bevent)


